classdef Function < handle
    
    methods(Abstract)
        of(obj, x)
    end
    
    methods
        function h = plus(obj, g)
           h = PlusFunction(obj, g); 
        end
        
        function h = mtimes(obj, g)
           h = DotFunction(obj, g); 
        end
        
        function y = ofAll(obj, x)
            %This function expects a matrix x with entries in (0,1) and
            %evaluates the function for every entry in the matrix.
            
           y = arrayfun(@(z) obj.of(z), x);
        end
    end
end

